#include <iostream>
#include <iomanip>
#include <cmath>

using namespace std;

class Tervektor	
{
   protected :
      double koord[3];	
   public :
      Tervektor operator+(Tervektor&);	
      Tervektor operator-(Tervektor&);	
      Tervektor operator*(double);	
      double operator*(Tervektor&);
      Tervektor operator%(Tervektor&);	
      double &operator[](int); 
      operator double(); 
};

Tervektor Tervektor::operator+(Tervektor& V)
{
   Tervektor B;  
	
   for(int i=0; i<3; i++)
	B[i]=(*this)[i]+V[i]; 
   return B;
}

Tervektor Tervektor::operator-(Tervektor& V)	
{
   Tervektor B;	
	
   for(int i=0; i<3; i++)
	B[i]=(*this)[i]-V[i]; 
   return B;
}

Tervektor Tervektor::operator*(double lambda)

{
   Tervektor B;
 	
   for(int i=0; i<3; i++)
	B[i]=(*this)[i]*lambda;
   return B;
}

double Tervektor::operator*(Tervektor &V)
{
   double Sum=0;

   for(int i=0; i<3; i++)
	   Sum+=(*this)[i]*V[i];
   return Sum;
}

Tervektor Tervektor::operator%(Tervektor &V)
{
   Tervektor B; 

   B[0]=(*this)[1]*V[2]-(*this)[2]*V[1];
   B[1]=(*this)[2]*V[0]-(*this)[0]*V[2];
   B[2]=(*this)[0]*V[1]-(*this)[1]*V[0];

   return B;
}

double &Tervektor::operator[](int i)
{
   return koord[i];
}

Tervektor::operator double()
					
{
   double Sum = 0;
   for(register int i = 0; i<3; i++)
	   Sum += (*this)[i] * (*this)[i];
   return sqrt(Sum);
}

istream &operator>>(istream &InStrm, Tervektor &V)
{
   cout << "A vektor x koordintja : "; InStrm >> V[0];
   cout << "A vektor y koordintja : "; InStrm >> V[1];
   cout << "A vektor z koordintja : "; InStrm >> V[2];
   return InStrm;
}

ostream &operator<<(ostream &OutStrm, Tervektor &V)
{
   OutStrm.setf(ios::fixed);
   OutStrm << "( " << setw(6) <<setprecision(2)<< V[0] << ", ";
   OutStrm << setw(6) <<setprecision(2) << V[1] << ", ";
   OutStrm << setw(6) <<setprecision(2) << V[2] << " )";
   return OutStrm;
}

Tervektor operator*(double lambda, Tervektor &V)

{
   Tervektor B; 
 	
   for(int i=0; i<3; i++) B[i]=V[i]*lambda;
   return B;
}

int main()
{ 
   setlocale(LC_ALL,"Hun"); 

   cout << "\n\t\t\tMveletek trvektorokkal \n\n";

   Tervektor a, b, c;

   cout << "Az els vektor adatai:\n\n";
   cin >> a;
   cout << "\nA msodik vektor adatai:\n\n";
   cin >> b;
   c=a+b;
   cout << "\nAz sszegvektor : " << c << endl;
   c=a-b;
   cout << "\nA klnbsgvektor: " << c << endl;
   cout << "\nA kt vektor skalris szorzata: " << a*b << endl;
   c=a%b;
   cout << "\nA kt vektor vektorilis szorzata: " << c << endl;

   cout << "\nA skalr szorztnyez rtke: ";
   double szorzo;
   cin >> szorzo;
   c=a*szorzo;
   cout << "\nAz els vektor jobbrl szorozva a skalrral: " << c << endl;
   c=szorzo*b;
   cout << "\nA msodik vektor balrl szorozva a skalrral: " << c << endl;
      
   cout << "\nAz els vektor hossza: " << (double) a << endl<< endl;

   system("pause");
   return 0;
}
